SmileGenerator (Jackson JSON Processor)
Date: 2013-07-14

org.codehaus.jackson.smile

## Class SmileGenerator

- java.lang.Object
- - org.codehaus.jackson.JsonGenerator
  - - org.codehaus.jackson.impl.JsonGeneratorBase
    - - org.codehaus.jackson.smile.SmileGenerator

- All Implemented Interfaces:
    Closeable, AutoCloseable, Versioned

      public class SmileGenerator
      extends JsonGeneratorBase

  `JsonGenerator` implementation for the experimental "Binary JSON Infoset".
  Author:
    tatu

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `SmileGenerator.Feature` Enumeration that defines all togglable features for Smile generators.
    `protected static class` | `SmileGenerator.SharedStringNode` Helper class used for keeping track of possibly shareable String references (for field names and/or short String values)

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected boolean` | `_bufferRecyclable` Flag that indicates whether the output buffer is recycable (and needs to be returned to recycler once we are done) or not.
    `protected int` | `_bytesWritten` Let's keep track of how many bytes have been output, may prove useful when debugging.
    `protected char[]` | `_charBuffer` Intermediate buffer in which characters of a String are copied before being encoded.
    `protected int` | `_charBufferLength`
    `protected IOContext` | `_ioContext`
    `protected OutputStream` | `_out`
    `protected byte[]` | `_outputBuffer` Intermediate buffer in which contents are buffered before being written using `_out`.
    `protected int` | `_outputEnd` Offset to index after the last valid index in `_outputBuffer`.
    `protected int` | `_outputTail` Pointer to the next available byte in `_outputBuffer`
    `protected int` | `_seenNameCount` Number of entries in `_seenNames`; -1 if no shared name detection is enabled
    `protected SmileGenerator.SharedStringNode[]` | `_seenNames` Raw data structure used for checking whether field name to write can be output using back reference or not.
    `protected int` | `_seenStringValueCount` Number of entries in `_seenStringValues`; -1 if no shared text value detection is enabled
    `protected SmileGenerator.SharedStringNode[]` | `_seenStringValues` Raw data structure used for checking whether String value to write can be output using back reference or not.
    `protected SmileBufferRecycler<SmileGenerator.SharedStringNode>` | `_smileBufferRecycler` Helper object used for low-level recycling of Smile-generator specific buffers.
    `protected int` | `_smileFeatures` Bit flag composed of bits that indicate which `SmileGenerator.Feature`s are enabled.
    `protected static ThreadLocal<SoftReference<SmileBufferRecycler<SmileGenerator.SharedStringNode>>>` | `_smileRecyclerRef` This `ThreadLocal` contains a `SoftReference` to a buffer recycler used to provide a low-cost buffer recycling for Smile-specific buffers.
    `protected static long` | `MAX_INT_AS_LONG`
    `protected static long` | `MIN_INT_AS_LONG`
    `protected static int` | `SURR1_FIRST`
    `protected static int` | `SURR1_LAST`
    `protected static int` | `SURR2_FIRST`
    `protected static int` | `SURR2_LAST`
    `protected static byte` | `TOKEN_BYTE_BIG_DECIMAL`
    `protected static byte` | `TOKEN_BYTE_BIG_INTEGER`
    `protected static byte` | `TOKEN_BYTE_FLOAT_32`
    `protected static byte` | `TOKEN_BYTE_FLOAT_64`
    `protected static byte` | `TOKEN_BYTE_INT_32`
    `protected static byte` | `TOKEN_BYTE_INT_64`
    `protected static byte` | `TOKEN_BYTE_LONG_STRING_ASCII`
    `protected static byte` | `TOKEN_BYTE_LONG_STRING_UNICODE`

    - ### Fields inherited from class org.codehaus.jackson.impl.JsonGeneratorBase

      `_cfgNumbersAsStrings, _closed, _features, _objectCodec, _writeContext`

    - ### Fields inherited from class org.codehaus.jackson.JsonGenerator

      `_cfgPrettyPrinter`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SmileGenerator(IOContext ctxt, int jsonFeatures, int smileFeatures, ObjectCodec codec, OutputStream out)`
    `SmileGenerator(IOContext ctxt, int jsonFeatures, int smileFeatures, ObjectCodec codec, OutputStream out, byte[] outputBuffer, int offset, boolean bufferRecyclable)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `_flushBuffer()`
    `protected UnsupportedOperationException` | `_notSupported()`
    `protected void` | `_releaseBuffers()`
    `protected static SmileBufferRecycler<SmileGenerator.SharedStringNode>` | `_smileBufferRecycler()`
    `protected void` | `_verifyValueWrite(String typeMsg)`
    `protected void` | `_write7BitBinaryWithLength(byte[] data, int offset, int len)`
    `protected void` | `_writeFieldName(SerializableString name)`
    `protected void` | `_writeFieldNameUnicode(SerializableString name, byte[] bytes)`
    `void` | `close()` Method called to close this generator, so that no more content can be written.
    `SmileGenerator` | `configure(SmileGenerator.Feature f, boolean state)`
    `SmileGenerator` | `disable(SmileGenerator.Feature f)`
    `SmileGenerator` | `enable(SmileGenerator.Feature f)`
    `void` | `flush()` Method called to flush any buffered content to the underlying target (output stream, writer), and to flush the target itself as well.
    `Object` | `getOutputTarget()` Method that can be used to get access to object that is used as target for generated output; this is usually either `OutputStream` or `Writer`, depending on what generator was constructed with.
    `boolean` | `isEnabled(SmileGenerator.Feature f)`
    `protected long` | `outputOffset()` Method for accessing offset of the next byte within the whole output stream that this generator has produced.
    `JsonGenerator` | `setPrettyPrinter(PrettyPrinter pp)` No way (or need) to indent anything, so let's block any attempts.
    `JsonGenerator` | `useDefaultPrettyPrinter()` No way (or need) to indent anything, so let's block any attempts.
    `void` | `writeBinary(Base64Variant b64variant, byte[] data, int offset, int len)` Method that will output given chunk of binary data as base64 encoded, as a complete String value (surrounded by double quotes).
    `void` | `writeBoolean(boolean state)` Method for outputting literal Json boolean value (one of Strings 'true' and 'false').
    `void` | `writeBytes(byte[] data, int offset, int len)` Method for directly inserting specified bytes in output at current position.
    `void` | `writeEndArray()` Method for writing closing marker of a JSON Array value (character ']'; plus possible white space decoration if pretty-printing is enabled).
    `void` | `writeEndObject()` Method for writing closing marker of a JSON Object value (character '}'; plus possible white space decoration if pretty-printing is enabled).
    `void` | `writeFieldName(SerializableString name)` Method similar to `JsonGenerator.writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.
    `void` | `writeFieldName(SerializedString name)` Method similar to `JsonGenerator.writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.
    `void` | `writeFieldName(String name)` Method for writing a field name (JSON String surrounded by double quotes: syntactically identical to a JSON String value), possibly decorated by white space if pretty-printing is enabled.
    `void` | `writeHeader()` Method that can be called to explicitly write Smile document header.
    `void` | `writeNull()` Method for outputting literal Json null value.
    `void` | `writeNumber(BigDecimal dec)` Method for outputting indicate Json numeric value.
    `void` | `writeNumber(BigInteger v)` Method for outputting given value as Json number.
    `void` | `writeNumber(double d)` Method for outputting indicate Json numeric value.
    `void` | `writeNumber(float f)` Method for outputting indicate Json numeric value.
    `void` | `writeNumber(int i)` Method for outputting given value as Json number.
    `void` | `writeNumber(long l)` Method for outputting given value as Json number.
    `void` | `writeNumber(String encodedValue)` Write method that can be used for custom numeric types that can not be (easily?) converted to "standard" Java number types.
    `void` | `writeRaw(byte b)` Method for directly inserting specified byte in output at current position.
    `void` | `writeRaw(char c)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
    `void` | `writeRaw(char[] text, int offset, int len)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
    `void` | `writeRaw(String text)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
    `void` | `writeRaw(String text, int offset, int len)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
    `void` | `writeRawUTF8String(byte[] text, int offset, int len)` Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String that is to be output as-is, without additional escaping (type of which depends on data format; backslashes for JSON).
    `void` | `writeRawValue(char[] text, int offset, int len)`
    `void` | `writeRawValue(String text)` Method that will force generator to copy input text verbatim without any modifications, but assuming it must constitute a single legal JSON value (number, string, boolean, null, Array or List).
    `void` | `writeRawValue(String text, int offset, int len)`
    `void` | `writeStartArray()` Method for writing starting marker of a JSON Array value (character '['; plus possible white space decoration if pretty-printing is enabled).
    `void` | `writeStartObject()` Method for writing starting marker of a JSON Object value (character '{'; plus possible white space decoration if pretty-printing is enabled).
    `void` | `writeString(char[] text, int offset, int len)` Method for outputting a String value.
    `void` | `writeString(SerializableString sstr)` Method similar to `JsonGenerator.writeString(String)`, but that takes `SerializableString` which can make this potentially more efficient to call as generator may be able to reuse quoted and/or encoded representation.
    `void` | `writeString(String text)` Method for outputting a String value.
    `void` | `writeStringField(String fieldName, String value)` Convenience method for outputting a field entry ("member") that has a String value.
    `void` | `writeUTF8String(byte[] text, int offset, int len)` Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String which has not been escaped using whatever escaping scheme data format requires (for JSON that is backslash-escaping for control characters and double-quotes; for other formats something else).

    - ### Methods inherited from class org.codehaus.jackson.impl.JsonGeneratorBase

      `_cantHappen, _reportError, _reportUnsupportedOperation, _throwInternal, _writeEndArray, _writeEndObject, _writeSimpleObject, _writeStartArray, _writeStartObject, copyCurrentEvent, copyCurrentStructure, disable, enable, getCodec, getOutputContext, isClosed, isEnabled, setCodec, version, writeObject, writeTree`

    - ### Methods inherited from class org.codehaus.jackson.JsonGenerator

      `canUseSchema, configure, disableFeature, enableFeature, getCharacterEscapes, getHighestEscapedChar, isFeatureEnabled, setCharacterEscapes, setFeature, setHighestNonEscapedChar, setSchema, writeArrayFieldStart, writeBinary, writeBinary, writeBinaryField, writeBooleanField, writeNullField, writeNumberField, writeNumberField, writeNumberField, writeNumberField, writeNumberField, writeObjectField, writeObjectFieldStart`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### TOKEN_BYTE_LONG_STRING_ASCII

          protected static final byte TOKEN_BYTE_LONG_STRING_ASCII

      See Also:
        Constant Field Values

    - #### TOKEN_BYTE_LONG_STRING_UNICODE

          protected static final byte TOKEN_BYTE_LONG_STRING_UNICODE

      See Also:
        Constant Field Values

    - #### TOKEN_BYTE_INT_32

          protected static final byte TOKEN_BYTE_INT_32

      See Also:
        Constant Field Values

    - #### TOKEN_BYTE_INT_64

          protected static final byte TOKEN_BYTE_INT_64

      See Also:
        Constant Field Values

    - #### TOKEN_BYTE_BIG_INTEGER

          protected static final byte TOKEN_BYTE_BIG_INTEGER

      See Also:
        Constant Field Values

    - #### TOKEN_BYTE_FLOAT_32

          protected static final byte TOKEN_BYTE_FLOAT_32

      See Also:
        Constant Field Values

    - #### TOKEN_BYTE_FLOAT_64

          protected static final byte TOKEN_BYTE_FLOAT_64

      See Also:
        Constant Field Values

    - #### TOKEN_BYTE_BIG_DECIMAL

          protected static final byte TOKEN_BYTE_BIG_DECIMAL

      See Also:
        Constant Field Values

    - #### SURR1_FIRST

          protected static final int SURR1_FIRST

      See Also:
        Constant Field Values

    - #### SURR1_LAST

          protected static final int SURR1_LAST

      See Also:
        Constant Field Values

    - #### SURR2_FIRST

          protected static final int SURR2_FIRST

      See Also:
        Constant Field Values

    - #### SURR2_LAST

          protected static final int SURR2_LAST

      See Also:
        Constant Field Values

    - #### MIN_INT_AS_LONG

          protected static final long MIN_INT_AS_LONG

      See Also:
        Constant Field Values

    - #### MAX_INT_AS_LONG

          protected static final long MAX_INT_AS_LONG

      See Also:
        Constant Field Values

    - #### _ioContext

          protected final IOContext _ioContext

    - #### _out

          protected final OutputStream _out

    - #### _smileFeatures

          protected int _smileFeatures

      Bit flag composed of bits that indicate which `SmileGenerator.Feature`s are enabled.

    - #### _smileBufferRecycler

          protected final SmileBufferRecycler<SmileGenerator.SharedStringNode> _smileBufferRecycler

      Helper object used for low-level recycling of Smile-generator specific buffers.
      Since:
        1.7

    - #### _outputBuffer

          protected byte[] _outputBuffer

      Intermediate buffer in which contents are buffered before being written using `_out`.

    - #### _outputTail

          protected int _outputTail

      Pointer to the next available byte in `_outputBuffer`

    - #### _outputEnd

          protected final int _outputEnd

      Offset to index after the last valid index in `_outputBuffer`. Typically same as length of the buffer.

    - #### _charBuffer

          protected char[] _charBuffer

      Intermediate buffer in which characters of a String are copied before being encoded.

    - #### _charBufferLength

          protected final int _charBufferLength

    - #### _bytesWritten

          protected int _bytesWritten

      Let's keep track of how many bytes have been output, may prove useful when debugging. This does not include bytes buffered in the output buffer, just bytes that have been written using underlying stream writer.

    - #### _seenNames

          protected SmileGenerator.SharedStringNode[] _seenNames

      Raw data structure used for checking whether field name to write can be output using back reference or not.

    - #### _seenNameCount

          protected int _seenNameCount

      Number of entries in `_seenNames`; -1 if no shared name detection is enabled

    - #### _seenStringValues

          protected SmileGenerator.SharedStringNode[] _seenStringValues

      Raw data structure used for checking whether String value to write can be output using back reference or not.

    - #### _seenStringValueCount

          protected int _seenStringValueCount

      Number of entries in `_seenStringValues`; -1 if no shared text value detection is enabled

    - #### _bufferRecyclable

          protected boolean _bufferRecyclable

      Flag that indicates whether the output buffer is recycable (and needs to be returned to recycler once we are done) or not.

    - #### _smileRecyclerRef

          protected static final ThreadLocal<SoftReference<SmileBufferRecycler<SmileGenerator.SharedStringNode>>> _smileRecyclerRef

      This `ThreadLocal` contains a `SoftReference` to a buffer recycler used to provide a low-cost buffer recycling for Smile-specific buffers.

  - ### Constructor Detail

    - #### SmileGenerator

          public SmileGenerator(IOContext ctxt,
                        int jsonFeatures,
                        int smileFeatures,
                        ObjectCodec codec,
                        OutputStream out)

    - #### SmileGenerator

          public SmileGenerator(IOContext ctxt,
                        int jsonFeatures,
                        int smileFeatures,
                        ObjectCodec codec,
                        OutputStream out,
                        byte[] outputBuffer,
                        int offset,
                        boolean bufferRecyclable)

  - ### Method Detail

    - #### writeHeader

          public void writeHeader()
                           throws IOException

      Method that can be called to explicitly write Smile document header. Note that usually you do not need to call this for first document to output, but rather only if you intend to write multiple root-level documents with same generator (and even in that case this is optional thing to do). As a result usually only `SmileFactory` calls this method.
      Throws:
        `IOException`

    - #### _smileBufferRecycler

          protected static final SmileBufferRecycler<SmileGenerator.SharedStringNode> _smileBufferRecycler()

    - #### useDefaultPrettyPrinter

          public JsonGenerator useDefaultPrettyPrinter()

      No way (or need) to indent anything, so let's block any attempts. (should we throw an exception instead?)
      Overrides:
        `useDefaultPrettyPrinter` in class `JsonGeneratorBase`
      Returns:
        Generator itself (this), to allow chaining

    - #### setPrettyPrinter

          public JsonGenerator setPrettyPrinter(PrettyPrinter pp)

      No way (or need) to indent anything, so let's block any attempts. (should we throw an exception instead?)
      Overrides:
        `setPrettyPrinter` in class `JsonGenerator`
      Returns:
        Generator itself (this), to allow chaining

    - #### getOutputTarget

          public Object getOutputTarget()

      Description copied from class: `JsonGenerator`
      Method that can be used to get access to object that is used as target for generated output; this is usually either `OutputStream` or `Writer`, depending on what generator was constructed with. Note that returned value may be null in some cases; including case where implementation does not want to exposed raw source to caller. In cases where output has been decorated, object returned here is the decorated version; this allows some level of interaction between users of generator and decorator object.

      In general use of this accessor should be considered as "last effort", i.e. only used if no other mechanism is applicable.

      Overrides:
        `getOutputTarget` in class `JsonGenerator`

    - #### writeFieldName

          public final void writeFieldName(String name)
                                    throws IOException,
                                           JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method for writing a field name (JSON String surrounded by double quotes: syntactically identical to a JSON String value), possibly decorated by white space if pretty-printing is enabled.

      Field names can only be written in Object context (check out JSON specification for details), when field name is expected (field names alternate with values).

      Specified by:
        `writeFieldName` in class `JsonGenerator`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeFieldName

          public final void writeFieldName(SerializedString name)
                                    throws IOException,
                                           JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method similar to `JsonGenerator.writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.

      Default implementation simple uses unprocessed name container in serialized String; implementations are strongly encouraged to make use of more efficient methods argument object has.

      Overrides:
        `writeFieldName` in class `JsonGenerator`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeFieldName

          public final void writeFieldName(SerializableString name)
                                    throws IOException,
                                           JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method similar to `JsonGenerator.writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.

      Default implementation simple uses unprocessed name container in serialized String; implementations are strongly encouraged to make use of more efficient methods argument object has.

      Overrides:
        `writeFieldName` in class `JsonGenerator`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeStringField

          public final void writeStringField(String fieldName,
                              String value)
                                      throws IOException,
                                             JsonGenerationException

      Description copied from class: `JsonGenerator`
      Convenience method for outputting a field entry ("member") that has a String value. Equivalent to:

            writeFieldName(fieldName);
            writeString(value);

      Note: many performance-sensitive implementations override this method

      Overrides:
        `writeStringField` in class `JsonGenerator`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### enable

          public SmileGenerator enable(SmileGenerator.Feature f)

    - #### disable

          public SmileGenerator disable(SmileGenerator.Feature f)

    - #### isEnabled

          public final boolean isEnabled(SmileGenerator.Feature f)

    - #### configure

          public SmileGenerator configure(SmileGenerator.Feature f,
                                 boolean state)

    - #### writeRaw

          public void writeRaw(byte b)
                        throws IOException,
                               JsonGenerationException

      Method for directly inserting specified byte in output at current position.

      NOTE: only use this method if you really know what you are doing.

      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeBytes

          public void writeBytes(byte[] data,
                        int offset,
                        int len)
                          throws IOException

      Method for directly inserting specified bytes in output at current position.

      NOTE: only use this method if you really know what you are doing.

      Throws:
        `IOException`

    - #### writeStartArray

          public final void writeStartArray()
                                     throws IOException,
                                            JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method for writing starting marker of a JSON Array value (character '['; plus possible white space decoration if pretty-printing is enabled).

      Array values can be written in any context where values are allowed: meaning everywhere except for when a field name is expected.

      Overrides:
        `writeStartArray` in class `JsonGeneratorBase`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeEndArray

          public final void writeEndArray()
                                   throws IOException,
                                          JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method for writing closing marker of a JSON Array value (character ']'; plus possible white space decoration if pretty-printing is enabled).

      Marker can be written if the innermost structured type is Array.

      Overrides:
        `writeEndArray` in class `JsonGeneratorBase`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeStartObject

          public final void writeStartObject()
                                      throws IOException,
                                             JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method for writing starting marker of a JSON Object value (character '{'; plus possible white space decoration if pretty-printing is enabled).

      Object values can be written in any context where values are allowed: meaning everywhere except for when a field name is expected.

      Overrides:
        `writeStartObject` in class `JsonGeneratorBase`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeEndObject

          public final void writeEndObject()
                                    throws IOException,
                                           JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method for writing closing marker of a JSON Object value (character '}'; plus possible white space decoration if pretty-printing is enabled).

      Marker can be written if the innermost structured type is Object, and the last written event was either a complete value, or START-OBJECT marker (see JSON specification for more details).

      Overrides:
        `writeEndObject` in class `JsonGeneratorBase`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### _writeFieldName

          protected final void _writeFieldName(SerializableString name)
                                        throws IOException,
                                               JsonGenerationException

      Throws:
        `IOException`
        `JsonGenerationException`

    - #### _writeFieldNameUnicode

          protected final void _writeFieldNameUnicode(SerializableString name,
                                    byte[] bytes)
                                               throws IOException,
                                                      JsonGenerationException

      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeString

          public void writeString(String text)
                           throws IOException,
                                  JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method for outputting a String value. Depending on context this means either array element, (object) field value or a stand alone String; but in all cases, String will be surrounded in double quotes, and contents will be properly escaped as required by JSON specification.
      Specified by:
        `writeString` in class `JsonGenerator`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeString

          public void writeString(char[] text,
                         int offset,
                         int len)
                           throws IOException,
                                  JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method for outputting a String value. Depending on context this means either array element, (object) field value or a stand alone String; but in all cases, String will be surrounded in double quotes, and contents will be properly escaped as required by JSON specification.
      Specified by:
        `writeString` in class `JsonGenerator`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeString

          public final void writeString(SerializableString sstr)
                                 throws IOException,
                                        JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method similar to `JsonGenerator.writeString(String)`, but that takes `SerializableString` which can make this potentially more efficient to call as generator may be able to reuse quoted and/or encoded representation.

      Default implementation just calls `JsonGenerator.writeString(String)`; sub-classes should override it with more efficient implementation if possible.

      Overrides:
        `writeString` in class `JsonGenerator`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeRawUTF8String

          public void writeRawUTF8String(byte[] text,
                                int offset,
                                int len)
                                  throws IOException,
                                         JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String that is to be output as-is, without additional escaping (type of which depends on data format; backslashes for JSON). However, quoting that data format requires (like double-quotes for JSON) will be added around the value if and as necessary.

      Note that some backends may choose not to support this method: for example, if underlying destination is a `Writer` using this method would require UTF-8 decoding. If so, implementation may instead choose to throw a `UnsupportedOperationException` due to ineffectiveness of having to decode input.

      Specified by:
        `writeRawUTF8String` in class `JsonGenerator`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeUTF8String

          public final void writeUTF8String(byte[] text,
                             int offset,
                             int len)
                                     throws IOException,
                                            JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String which has not been escaped using whatever escaping scheme data format requires (for JSON that is backslash-escaping for control characters and double-quotes; for other formats something else). This means that textual JSON backends need to check if value needs JSON escaping, but otherwise can just be copied as is to output. Also, quoting that data format requires (like double-quotes for JSON) will be added around the value if and as necessary.

      Note that some backends may choose not to support this method: for example, if underlying destination is a `Writer` using this method would require UTF-8 decoding. In this case generator implementation may instead choose to throw a `UnsupportedOperationException` due to ineffectiveness of having to decode input.

      Specified by:
        `writeUTF8String` in class `JsonGenerator`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeRaw

          public void writeRaw(String text)
                        throws IOException,
                               JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

      Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

      Specified by:
        `writeRaw` in class `JsonGenerator`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeRaw

          public void writeRaw(String text,
                      int offset,
                      int len)
                        throws IOException,
                               JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

      Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

      Specified by:
        `writeRaw` in class `JsonGenerator`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeRaw

          public void writeRaw(char[] text,
                      int offset,
                      int len)
                        throws IOException,
                               JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

      Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

      Specified by:
        `writeRaw` in class `JsonGenerator`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeRaw

          public void writeRaw(char c)
                        throws IOException,
                               JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

      Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

      Specified by:
        `writeRaw` in class `JsonGenerator`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeRawValue

          public void writeRawValue(String text)
                             throws IOException,
                                    JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method that will force generator to copy input text verbatim without any modifications, but assuming it must constitute a single legal JSON value (number, string, boolean, null, Array or List). Assuming this, proper separators are added if and as needed (comma or colon), and generator state updated to reflect this.
      Overrides:
        `writeRawValue` in class `JsonGeneratorBase`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeRawValue

          public void writeRawValue(String text,
                           int offset,
                           int len)
                             throws IOException,
                                    JsonGenerationException

      Overrides:
        `writeRawValue` in class `JsonGeneratorBase`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeRawValue

          public void writeRawValue(char[] text,
                           int offset,
                           int len)
                             throws IOException,
                                    JsonGenerationException

      Overrides:
        `writeRawValue` in class `JsonGeneratorBase`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeBinary

          public void writeBinary(Base64Variant b64variant,
                         byte[] data,
                         int offset,
                         int len)
                           throws IOException,
                                  JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method that will output given chunk of binary data as base64 encoded, as a complete String value (surrounded by double quotes). This method defaults

      Note: because Json Strings can not contain unescaped linefeeds, if linefeeds are included (as per last argument), they must be escaped. This adds overhead for decoding without improving readability. Alternatively if linefeeds are not included, resulting String value may violate the requirement of base64 RFC which mandates line-length of 76 characters and use of linefeeds. However, all `JsonParser` implementations are required to accept such "long line base64"; as do typical production-level base64 decoders.

      Specified by:
        `writeBinary` in class `JsonGenerator`
      Parameters:
        `b64variant` - Base64 variant to use: defines details such as whether padding is used (and if so, using which character); what is the maximum line length before adding linefeed, and also the underlying alphabet to use.
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeBoolean

          public void writeBoolean(boolean state)
                            throws IOException,
                                   JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method for outputting literal Json boolean value (one of Strings 'true' and 'false'). Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeBoolean` in class `JsonGenerator`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeNull

          public void writeNull()
                         throws IOException,
                                JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method for outputting literal Json null value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeNull` in class `JsonGenerator`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeNumber

          public void writeNumber(int i)
                           throws IOException,
                                  JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method for outputting given value as Json number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeNumber` in class `JsonGenerator`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeNumber

          public void writeNumber(long l)
                           throws IOException,
                                  JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method for outputting given value as Json number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeNumber` in class `JsonGenerator`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeNumber

          public void writeNumber(BigInteger v)
                           throws IOException,
                                  JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method for outputting given value as Json number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeNumber` in class `JsonGenerator`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeNumber

          public void writeNumber(double d)
                           throws IOException,
                                  JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method for outputting indicate Json numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeNumber` in class `JsonGenerator`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeNumber

          public void writeNumber(float f)
                           throws IOException,
                                  JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method for outputting indicate Json numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeNumber` in class `JsonGenerator`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeNumber

          public void writeNumber(BigDecimal dec)
                           throws IOException,
                                  JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method for outputting indicate Json numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeNumber` in class `JsonGenerator`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### writeNumber

          public void writeNumber(String encodedValue)
                           throws IOException,
                                  JsonGenerationException,
                                  UnsupportedOperationException

      Description copied from class: `JsonGenerator`
      Write method that can be used for custom numeric types that can not be (easily?) converted to "standard" Java number types. Because numbers are not surrounded by double quotes, regular `JsonGenerator.writeString(java.lang.String)` method can not be used; nor `JsonGenerator.writeRaw(java.lang.String)` because that does not properly handle value separators needed in Array or Object contexts.

      Note: because of lack of type safety, some generator implementations may not be able to implement this method. For example, if a binary json format is used, it may require type information for encoding; similarly for generator-wrappers around Java objects or Json nodes. If implementation does not implement this method, it needs to throw `UnsupportedOperationException`.

      Specified by:
        `writeNumber` in class `JsonGenerator`
      Throws:
        `IOException`
        `JsonGenerationException`
        `UnsupportedOperationException`

    - #### _verifyValueWrite

          protected final void _verifyValueWrite(String typeMsg)
                                          throws IOException,
                                                 JsonGenerationException

      Specified by:
        `_verifyValueWrite` in class `JsonGeneratorBase`
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### flush

          public final void flush()
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method called to flush any buffered content to the underlying target (output stream, writer), and to flush the target itself as well.
      Specified by:
        `flush` in class `JsonGeneratorBase`
      Throws:
        `IOException`

    - #### close

          public void close()
                     throws IOException

      Description copied from class: `JsonGenerator`
      Method called to close this generator, so that no more content can be written.

      Whether the underlying target (stream, writer) gets closed depends on whether this generator either manages the target (i.e. is the only one with access to the target -- case if caller passes a reference to the resource such as File, but not stream); or has feature `JsonGenerator.Feature.AUTO_CLOSE_TARGET` enabled. If either of above is true, the target is also closed. Otherwise (not managing, feature not enabled), target is not closed.

      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Overrides:
        `close` in class `JsonGeneratorBase`
      Throws:
        `IOException`

    - #### _write7BitBinaryWithLength

          protected void _write7BitBinaryWithLength(byte[] data,
                                        int offset,
                                        int len)
                                             throws IOException

      Throws:
        `IOException`

    - #### _releaseBuffers

          protected void _releaseBuffers()

      Specified by:
        `_releaseBuffers` in class `JsonGeneratorBase`

    - #### _flushBuffer

          protected final void _flushBuffer()
                                     throws IOException

      Throws:
        `IOException`

    - #### outputOffset

          protected long outputOffset()

      Method for accessing offset of the next byte within the whole output stream that this generator has produced.

    - #### _notSupported

          protected UnsupportedOperationException _notSupported()